"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var entity_model_1 = require('../models/entity.model');
var form_input_component_1 = require('./inputs/form-input.component');
var form_checkbox_component_1 = require('./inputs/form-checkbox.component');
var form_select_component_1 = require('./inputs/form-select.component');
var form_textarea_component_1 = require('./inputs/form-textarea.component');
var FormFieldComponent = (function () {
    function FormFieldComponent() {
        this.valueChanged = new core_1.EventEmitter();
        this._field = new entity_model_1.FieldDefinition();
    }
    FormFieldComponent.prototype.ngOnInit = function () {
        this._field = this.entity.getPropertyDescription(this.property);
    };
    FormFieldComponent.prototype.isInput = function () {
        return this._field.input.isHidden() || this._field.input.isText();
    };
    FormFieldComponent.prototype.isTextarea = function () {
        return this._field.input.isTextarea();
    };
    FormFieldComponent.prototype.isSelect = function () {
        return this._field.input.isSelect();
    };
    FormFieldComponent.prototype.isCheckbox = function () {
        return this._field.input.isCheckbox();
    };
    FormFieldComponent.prototype.onValueChanged = function (value) {
        this.valueChanged.next(value);
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', entity_model_1.Entity)
    ], FormFieldComponent.prototype, "entity", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], FormFieldComponent.prototype, "property", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], FormFieldComponent.prototype, "valueChanged", void 0);
    FormFieldComponent = __decorate([
        core_1.Component({
            selector: 'form-field',
            directives: [form_input_component_1.FormInputComponent, form_checkbox_component_1.FormCheckboxComponent, form_select_component_1.FormSelectComponent, form_textarea_component_1.FormTextareaComponent],
            template: "\n        <form-textarea *ngIf=\"isTextarea()\" [entity]=\"entity\" [property]=\"property\" (valueChanged)=\"onValueChanged(value)\"></form-textarea>\n        <form-input *ngIf=\"isInput()\" [entity]=\"entity\" [property]=\"property\" (valueChanged)=\"onValueChanged(value)\"></form-input>\n        <form-select *ngIf=\"isSelect()\" [entity]=\"entity\" [property]=\"property\" (valueChanged)=\"onValueChanged(value)\"></form-select>\n        <form-checkbox *ngIf=\"isCheckbox()\" [entity]=\"entity\" [property]=\"property\" (valueChanged)=\"onValueChanged(value)\"></form-checkbox>\n    "
        }), 
        __metadata('design:paramtypes', [])
    ], FormFieldComponent);
    return FormFieldComponent;
}());
exports.FormFieldComponent = FormFieldComponent;
//# sourceMappingURL=form-field.component.js.map