"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var entity_model_1 = require('../../models/entity.model');
var FormBaseComponent = (function () {
    function FormBaseComponent() {
        this.valueChanged = new core_1.EventEmitter();
        this._errorMessage = '';
        this._values = [];
    }
    FormBaseComponent.prototype.ngOnInit = function () {
        this._entityName = this.entity.constructor.name.toLowerCase();
        this._definition = this.entity.getPropertyDescription(this.property);
        this._fieldIdentifier = this._entityName + '-' + this.property;
        this._className = this.getClassName();
        this._iconClass = this.getIconClass();
        this._showIcon = this.hasIcon();
        this._type = this.getType();
        this._placeholder = this._definition.input.placeholder;
        this._readonly = this._definition.input.readOnly;
        this._required = this._definition.required;
        this._label = this._definition.input.label;
        this._values = this._definition.input.values;
        var value = this.entity.getPropertyValue(this.property);
        if (value)
            this._value = value;
        else {
            if (this._values.length > 0) {
                this._value = this._values[0].id;
                this.entity.setPropertyValue(this.property, this._value);
            }
            else
                this._value = '';
        }
    };
    FormBaseComponent.prototype.getIconClass = function () {
        return this.hasIcon() ? 'fa form-control-feedback left ' + this._definition.input.icon : 'form-control-feedback left';
    };
    FormBaseComponent.prototype.hasIcon = function () {
        return (this._definition.input.icon != null && this._definition.input.icon != '');
    };
    FormBaseComponent.prototype.getClassName = function () {
        return this.hasIcon() ? 'form-control has-feedback-left' : 'form-control';
    };
    FormBaseComponent.prototype.onValueChanged = function (event) {
        this.entity.setPropertyValue(this.property, event.target.value);
        this.valueChanged.next(event.target.value);
    };
    FormBaseComponent.prototype.getType = function () {
        return this._definition.input.isHidden() ? 'hidden' : 'text';
    };
    FormBaseComponent.prototype.isValid = function () {
        var valid = this.entity.isPropertyValid(this.property);
        this._errorMessage = this._definition.getError();
        return valid;
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', entity_model_1.Entity)
    ], FormBaseComponent.prototype, "entity", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], FormBaseComponent.prototype, "property", void 0);
    __decorate([
        core_1.Output(), 
        __metadata('design:type', Object)
    ], FormBaseComponent.prototype, "valueChanged", void 0);
    return FormBaseComponent;
}());
exports.FormBaseComponent = FormBaseComponent;
//# sourceMappingURL=form-base.component.js.map