"use strict";
var enums_model_1 = require("./enums.model");
var InputDefinition = (function () {
    function InputDefinition() {
        this.type = enums_model_1.InputType.None;
        this.readOnly = false;
        this.values = [];
    }
    InputDefinition.fromMap = function (map) {
        var definition = new InputDefinition();
        Object.keys(map).forEach(function (property) {
            definition[property] = map[property];
        });
        return definition;
    };
    InputDefinition.prototype.isNone = function () { return this.type == enums_model_1.InputType.None; };
    InputDefinition.prototype.isHidden = function () { return this.type == enums_model_1.InputType.Hidden; };
    InputDefinition.prototype.isMap = function () { return this.type == enums_model_1.InputType.Map; };
    InputDefinition.prototype.isSelect = function () { return this.type == enums_model_1.InputType.Select; };
    InputDefinition.prototype.isText = function () { return this.type == enums_model_1.InputType.Text; };
    InputDefinition.prototype.isTextarea = function () { return this.type == enums_model_1.InputType.Textarea; };
    InputDefinition.prototype.isCheckbox = function () { return this.type == enums_model_1.InputType.Checkbox; };
    InputDefinition.prototype.isEntity = function () { return this.type == enums_model_1.InputType.Entity; };
    InputDefinition.prototype.isEntityCollection = function () { return this.type == enums_model_1.InputType.EntityCollection; };
    return InputDefinition;
}());
exports.InputDefinition = InputDefinition;
//# sourceMappingURL=input.model.js.map